## cxx-rust-cssparser 0.0.0+p24.04+vunstable+git20251022.0041

=== debian/changelog ===
cxx-rust-cssparser (0.0.0+p24.04+vunstable+git20251022.0041-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 22 Oct 2025 00:41:36 +0000

cxx-rust-cssparser (0.0.0-0neon) noble; urgency=medium

  * Initial packaging

 -- Neon CI <neon@kde.org>  Mon, 23 Jun 2025 19:26:11 +0000

## cxx-rust-cssparser 0.0.0+p24.04+vunstable+git20251203.0048

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: 2025 Arjen Hiemstra <ahiemstra@heimr.nl>

cmake_minimum_required(VERSION 3.20)

project(cxx-rust-cssparser VERSION 1.0.0)

set(KF_DEP_VERSION 6.10.0)

include(FeatureSummary)
find_package(ECM ${KF_DEP_VERSION} NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(KDEGitCommitHooks)
include(ECMGenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateQDoc)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_AUTOMOC FALSE)
set(CMAKE_AUTORCC FALSE)

set(CMAKE_CXX_VISIBILITY_PRESET "default")

kde_enable_exceptions()

add_subdirectory(rust)
add_subdirectory(cpp)

add_subdirectory(examples)

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX cssparser
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparser_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparserConfigVersion.cmake"
    SOVERSION 1
)

configure_package_config_file(
    "cxx-rust-cssparserConfig.cmake.in"
    "cxx-rust-cssparserConfig.cmake"
    INSTALL_DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/cxx-rust-cssparser
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparserConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparserConfigVersion.cmake"
    DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/cxx-rust-cssparser
    COMPONENT Devel
)

install(EXPORT cxx-rust-cssparserTargets
    DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/cxx-rust-cssparser
    FILE cxx-rust-cssparserTargets.cmake
    # NAMESPACE K::
)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== cpp/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: 2025 Arjen Hiemstra <ahiemstra@heimr.nl>

add_library(cxx-rust-cssparser)

target_sources(cxx-rust-cssparser PRIVATE
    CssParser.cpp
    CssParser.h
)

ecm_generate_export_header(cxx-rust-cssparser
    BASE_NAME cssparser
    VERSION ${PROJECT_VERSION}
    DEPRECATED_BASE_VERSION 0
    EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
)

target_link_libraries(cxx-rust-cssparser PRIVATE cxx-rust-cssparser-impl)

target_include_directories(cxx-rust-cssparser PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/rust>"
    "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/cxx-rust-cssparser>"
)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    # On FreeBSD, we cannot compile with "-Wl,--no-undefined" because that will
    # fail to find the "environ" symbol.
    string(REPLACE "-Wl,--no-undefined " " " CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
endif()

set_target_properties(cxx-rust-cssparser PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

install(TARGETS cxx-rust-cssparser EXPORT cxx-rust-cssparserTargets ${KDE_INSTALL_DEFAULT_ARGS})
install(FILES
    CssParser.h
    ${CMAKE_CURRENT_BINARY_DIR}/cssparser_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/cxx-rust-cssparser
)

=== examples/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: 2025 Arjen Hiemstra <ahiemstra@heimr.nl>

add_executable(cxx-rust-cssparser-parse main.cpp)

target_link_libraries(cxx-rust-cssparser-parse cxx-rust-cssparser)

install(TARGETS cxx-rust-cssparser-parse DESTINATION ${CMAKE_INSTALL_BINDIR})

=== rust/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: 2025 Arjen Hiemstra <ahiemstra@heimr.nl>

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CARGO_CMD cargo build --verbose)
    set(TARGET_DIR "debug")
else()
    set(CARGO_CMD cargo build --release --verbose)
    set(TARGET_DIR "release")
endif()

set(CARGO_BUILD_TEST_CMD "")
if (BUILD_TESTING)
    set(CARGO_BUILD_TEST_CMD cargo test --no-run)
endif()

set(RUST_LIB "${CMAKE_CURRENT_BINARY_DIR}/${TARGET_DIR}/libcxx_rust_cssparser.a")
set(RUST_CXX "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparser-impl.cpp")
set(RUST_HEADER "${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparser-impl.h")

add_library(cxx-rust-cssparser-impl STATIC ${RUST_CXX})
add_custom_command(
    OUTPUT ${RUST_LIB} ${RUST_CXX}
    COMMAND CARGO_TARGET_DIR=${CMAKE_CURRENT_BINARY_DIR} RUSTFLAGS="${RUST_FLAGS}" ${CARGO_CMD}
    COMMAND CARGO_TARGET_DIR=${CMAKE_CURRENT_BINARY_DIR} RUSTFLAGS="${RUST_FLAGS}" ${CARGO_BUILD_TEST_CMD}
    COMMAND cp ${CMAKE_CURRENT_BINARY_DIR}/cxxbridge/cxx-rust-cssparser/src/ffi.rs.cc ${RUST_CXX}
    COMMAND cp ${CMAKE_CURRENT_BINARY_DIR}/cxxbridge/cxx-rust-cssparser/src/ffi.rs.h ${CMAKE_CURRENT_BINARY_DIR}/cxx-rust-cssparser-impl.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}

    DEPENDS
    build.rs
    Cargo.toml

    src/ffi.rs
    src/lib.rs
    src/property.rs
    src/selector.rs
    src/stylerule.rs
    src/stylesheet.rs
    src/value.rs

    src/details/identifier.rs
    src/details/mod.rs
    src/details/rulesparser.rs
    src/details/selectorparser.rs

    src/details/property/definitionparser.rs
    src/details/property/function.rs
    src/details/property/mod.rs
    src/details/property/syntax.rs
    src/details/property/value.rs
)

set_target_properties(cxx-rust-cssparser-impl PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
target_include_directories(cxx-rust-cssparser-impl PUBLIC ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(cxx-rust-cssparser-impl pthread dl ${RUST_LIB})

if (BUILD_TESTING)
    add_test(NAME rust COMMAND cargo test)
    set_tests_properties(rust PROPERTIES ENVIRONMENT "CARGO_TARGET_DIR=${CMAKE_CURRENT_BINARY_DIR}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

install(FILES ${RUST_HEADER} DESTINATION ${KDE_INSTALL_INCLUDEDIR}/cxx-rust-cssparser)

=== debian/changelog ===
cxx-rust-cssparser (0.0.0+p24.04+vunstable+git20251203.0048-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Dec 2025 00:48:42 +0000

=== debian/control ===
Source: cxx-rust-cssparser
Section: libs
Priority: optional
Build-Depends: cargo-1.82,
               cmake,
               corrosion,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               pkg-kde-tools-neon,
               qt6-base-dev,
               rustc-1.82
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/libraries/cxx-rust-cssparser
Rules-Requires-Root: no
Vcs-Git: https://invent.kde.org/neon/neon-packaging/cxx-rust-cssparser.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/cxx-rust-cssparser
Maintainer: Neon CI <neon@kde.org>

Package: cxx-rust-cssparser-dev
Section: libdevel
Architecture: any
Depends: cxx-rust-cssparser (= ${binary:Version}),
         kf6-extra-cmake-modules,
         qt6-base-dev,
         ${misc:Depends}
Description: KDE's cxx-rust-cssparser library
 A C++ library for parsing CSS that uses the Rust cssparser crate internally.
 .
 This package contains the library development files.

Package: cxx-rust-cssparser
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KDE's cxx-rust-cssparser library
 A C++ library for parsing CSS that uses the Rust cssparser crate internally.
 .
 This package contains the cxx-rust-cssparser main library.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

export DEB_CFLAGS_MAINT_APPEND = -fPIC
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC
export DEB_LDFLAGS_MAINT_APPEND = -fPIC

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_TESTING=OFF

override_dh_auto_test:
	#do not run tests
	true

## cxx-rust-cssparser 0.0.0+p24.04+vunstable+git20251208.0220

=== debian/changelog ===
cxx-rust-cssparser (0.0.0+p24.04+vunstable+git20251208.0220-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 02:20:42 +0000
